/**
 * Returns the current browser name.
 *
 * @property browser.current
 * @type String
 */

/**
 * Returns the current browser major and minor version.
 *
 * @property browser.version
 * @type Object
 */

/**
 * Returns <code>true</code> if the user's browser is Microsoft Edge Legacy. Does not return true for the newer Chromium-based Microsoft Edge.
 *
 * @method browser.isEdge
 * @return {Boolean} Returns <code>true</code> if the user's browser is Microsoft Edge Legacy.
 */

/**
 * Returns <code>true</code> if the user's browser is Chromium based, such as Google Chrome or newer versions of Microsoft Edge.
 *
 * @method browser.isChromium
 * @return {Boolean} Returns <code>true</code> if the user's browser is Chromium based.
 */

/**
 * Returns <code>true</code> if the user's browser is Microsoft Internet Explorer.
 *
 * @method browser.isIE
 * @return {Boolean} Returns <code>true</code> if the user's browser is Microsoft Internet Explorer.
 */

/**
 * Returns <code>true</code> if the user's browser is Opera.
 *
 * @method browser.isOpera
 * @return {Boolean} Returns <code>true</code> if the user's browser is Opera.
 */

/**
 * Returns <code>true</code> if the user's browser is Firefox.
 *
 * @method browser.isFirefox
 * @return {Boolean} Returns <code>true</code> if the user's browser is Firefox.
 */

/**
 * Returns <code>true</code> if the user's browser is Safari.
 *
 * @method browser.isSafari
 * @return {Boolean} Returns <code>true</code> if the user's browser is Safari.
 */

/**
 * Returns the current operating system name.
 *
 * @property os.current
 * @type String
 */

/**
 * Returns the current operating system major and minor version.
 *
 * @property os.version
 * @type Object
 */

/**
 * Returns <code>true</code> if the user's operating system is Microsoft Windows.
 *
 * @method os.isWindows
 * @return {Boolean} Returns <code>true</code> if the user's operating system is Microsoft Windows.
 */

/**
 * Returns <code>true</code> if the user's operating system is iOS.
 *
 * @method os.isiOS
 * @return {Boolean} Returns <code>true</code> if the user's operating system is iOS.
 */

/**
 * Returns <code>true</code> if the user's operating system is Android.
 *
 * @method os.isAndroid
 * @return {Boolean} Returns <code>true</code> if the user's operating system is Android.
 */

/**
 * Returns <code>true</code> if the user's operating system is macOS.
 *
 * @method os.isMacOS
 * @return {Boolean} Returns <code>true</code> if the user's operating system is macOS.
 */

/**
 * Returns <code>true</code> if the user's operating system is Linux.
 *
 * @method os.isLinux
 * @return {Boolean} Returns <code>true</code> if the user's operating system is Linux.
 */

/**
 * Returns <code>true</code> if the user's operating system is Solaris.
 *
 * @method os.isSolaris
 * @return {Boolean} Returns <code>true</code> if the user's operating system is Solaris.
 */

/**
 * Returns <code>true</code> if the user's operating system is FreeBSD.
 *
 * @method os.isFreeBSD
 * @return {Boolean} Returns <code>true</code> if the user's operating system is FreeBSD.
 */

/**
 * Returns <code>true</code> if the user's operating system is ChromeOS.
 *
 * @method os.isChromeOS
 * @return {Boolean} Returns <code>true</code> if the user's operating system is ChromeOS.
 */

/**
 * Returns <code>true</code> if the user's device is a desktop device.
 *
 * @method deviceType.isDesktop
 * @return {Boolean} Returns <code>true</code> if the user's device is a desktop device.
 */

/**
 * Returns <code>true</code> if the user's device is an iPad.
 *
 * @method deviceType.isiPad
 * @return {Boolean} Returns <code>true</code> if the user's device is an iPad.
 */

/**
 * Returns <code>true</code> if the user's device is an iPhone.
 *
 * @method deviceType.isiPhone
 * @return {Boolean} Returns <code>true</code> if the user's device is an iPhone.
 */

/**
 * Returns <code>true</code> if the user's device is a phone.
 *
 * @method deviceType.isPhone
 * @return {Boolean} Returns <code>true</code> if the user's device is a phone.
 */

/**
 * Returns <code>true</code> if the user's device is a tablet.
 *
 * @method deviceType.isTablet
 * @return {Boolean} Returns <code>true</code> if the user's device is a tablet.
 */

/**
 * Returns <code>true</code> if the user's device is a touch device.
 *
 * @method deviceType.isTouch
 * @return {Boolean} Returns <code>true</code> if the user's device is a touch device.
 */

/**
 * Returns <code>true</code> if the user's device is a WebView device.
 *
 * @method deviceType.isWebView
 * @return {Boolean} Returns <code>true</code> if the user's device is a WebView device.
 */
